import 'package:firebase_auth_helper/firebase_auth_helper.dart';
import 'package:firebase_auth_helper/src/widgets/auth_state_wrapper.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

main() {
  final AuthProvider authProvider = FirebaseAuthProvider();
  authProvider.signOut();
  final signInResult = authProvider.emailPasswordSignIn(
      LoginCredentials("some@email.com", "secretPassword"));
  final AuthUser currentUser = authProvider.currentAuthUser;
  print("""
    Currently logged in as: ${currentUser.displayName},
    ${currentUser.email},
    ${currentUser.id}""");
  authProvider.authStateChanged.listen((authUser) {
    print("Auth user changed");
    print("Is logged in: ${authUser.isLoggedIn}");
    if (authUser.isLoggedIn) {
      print(
          "Currently logged in as: ${currentUser.displayName}, ${currentUser.email}, ${currentUser.id}");
    }
  });

  final AuthStateWrapper authStateWrapper = AuthStateWrapper(
      authProvider: authProvider,
      signedIn: (context) => HomePage(),
      notSignedIn: (context) => LoginPage(),
      loading: (context) => const CircularProgressIndicator(),
      error: (context, error) => Text("Error occurred: $error"));
}

Widget HomePage() => const Text("Logged in");

Widget LoginPage() => const Text("Please login");
