import 'package:firebase_auth_helper/firebase_auth_helper.dart';
import 'package:flutter_test/flutter_test.dart';

main() {
  late final FirebaseAuthProvider authProvider;

  setUp(() {
    authProvider = FirebaseAuthProvider();
    authProvider.signOut();
  });

  test("authUserChanged emits events when firebase user is logged in/out", () async {
    const uid1 = "user1";
    const uid2 = "user2";
    final result = authProvider.authStateChanged;

    await authProvider.emailPasswordSignIn(credentials);

    expect(
        result,
        emitsInOrder([
          isA<AuthUser>()
              .having((user) => user.isLoggedIn, "isLoggedIn", false),
          isA<AuthUser>()
              .having((user) => user.isLoggedIn, "isLoggedIn", true)
              .having((user) => user.id, "id", uid1),
          isA<AuthUser>()
              .having((user) => user.isLoggedIn, "isLoggedIn", false),
          isA<AuthUser>()
              .having((user) => user.isLoggedIn, "isLoggedIn", true)
              .having((user) => user.id, "id", uid2),
        ]));
  });
}
